class IngamePanelCustomPanel extends TemplateElement {
    constructor() {
        super(...arguments);

        this.panelActive = false;
        this.started = false;
        this.ingameUi = null;
        this.busy = false;
        this.debugEnabled = false;

        if (this.debugEnabled) {
            var self = this;
            setTimeout(() => {
                self.isDebugEnabled();
            }, 1000);
        } else {
            this.initialize();
        }
    }
    isDebugEnabled() {
        var self = this;
        if (typeof g_modDebugMgr != "undefined") {
            g_modDebugMgr.AddConsole(null);
            g_modDebugMgr.AddDebugButton("Identifier", function() {
                console.log('Identifier');
                console.log(self.instrumentIdentifier);
            });
            g_modDebugMgr.AddDebugButton("TemplateID", function() {
                console.log('TemplateID');
                console.log(self.templateID);
            });
            g_modDebugMgr.AddDebugButton("Source", function() {
                console.log('Source');
                console.log(window.document.documentElement.outerHTML);
            });
			g_modDebugMgr.AddDebugButton("close", function() {
				console.log('close');
				if (self.ingameUi) {
					console.log('ingameUi');
					self.ingameUi.closePanel();
				}
			});
            this.initialize();
        } else {
            Include.addScript("/JS/debug.js", function () {
                if (typeof g_modDebugMgr != "undefined") {
                    g_modDebugMgr.AddConsole(null);
                    g_modDebugMgr.AddDebugButton("Identifier", function() {
                        console.log('Identifier');
                        console.log(self.instrumentIdentifier);
                    });
                    g_modDebugMgr.AddDebugButton("TemplateID", function() {
                        console.log('TemplateID');
                        console.log(self.templateID);
                    });
                    g_modDebugMgr.AddDebugButton("Source", function() {
                        console.log('Source');
                        console.log(window.document.documentElement.outerHTML);
                    });
                    g_modDebugMgr.AddDebugButton("close", function() {
                        console.log('close');
                        if (self.ingameUi) {
                            console.log('ingameUi');
                            self.ingameUi.closePanel();
                        }
                    });
                    self.initialize();
                } else {
                    setTimeout(() => {
                        self.isDebugEnabled();
                    }, 2000);
                }
            });
        }
    }
    connectedCallback() {
        super.connectedCallback();

        var self = this;
        this.ingameUi = this.querySelector('ingame-ui');

        this.iframeElement = document.getElementById("SSCPanelIframe");
      
        if (this.ingameUi) {
            this.ingameUi.addEventListener("panelActive", (e) => {
                console.log('panelActive');
                self.panelActive = true;
                if (self.iframeElement) {
                    self.iframeElement.src = 'https://www.ssc-tracker.org/index.html?view=1';
                }
            });
            this.ingameUi.addEventListener("panelInactive", (e) => {
                console.log('panelInactive');
                self.panelActive = false;
                if (self.iframeElement) {
                    self.iframeElement.src = '';
                }
            });
            this.ingameUi.addEventListener("onResizeElement", () => {
                //self.updateImage();
            });
            this.ingameUi.addEventListener("dblclick", () => {
                document.getElementById("SSCPanel").classList.toggle("interact");
			});
        }
    }
    initialize() {
        if (this.started) {
            return;
        }

        document.body.classList.add("interact");

        setTimeout(() => {
            if(GetStoredData("ssc-ui")) {
                this.grid = GetStoredData("ssc-ui");
            }
        },500)

        window.addEventListener('message',(event) => {

            if(event.data == "takeFocus") {
                document.body.classList.remove("interact");

                setTimeout( unblockSensor ,1000)
            }

            if(event.data == "connected") {
                this.loadflightplan();

                if(this.grid) {
                    this.setVar("ssc-ui",this.grid);
                } else {
                    if(GetStoredData("ssc-ui")) {
                        this.grid = GetStoredData("ssc-ui");
                        this.setVar("ssc-ui",this.grid);
                    }
                }
            }

            if(event.data[0] == "setObject") {
                window[event.data[1]] = JSON.parse(event.data[2]);
            }

            if(event.data[1] == "ssc-ui") {
                SetStoredData("ssc-ui", event.data[2]);
            }

        })

        this.started = true;
    }
    disconnectedCallback() {
        super.disconnectedCallback();
    }
    updateImage() {

    }
	
	setData(key,value) {
        let child = this.iframeElement.contentWindow;
        value = typeof(value) == "object" ? JSON.stringify(value) : value;

        child.postMessage(["setVar", key, value],'*');
    }

    setObject(key,ob) {
        let child = this.iframeElement.contentWindow;
        child.postMessage(["setObject", key, JSON.stringify(ob)],'*');
    }

    setVar(key,val) {
        let child = this.iframeElement.contentWindow;
        child.postMessage(["setVar", key, val],'*');
    }
}
window.customElements.define("ssc-ingamepanel", IngamePanelCustomPanel);
checkAutoload();
