let cOnline = '<img src="world.png">&nbsp;';
let cAir = '<img src="air.png">&nbsp;';
let cEngine = '<img src="flash.png">&nbsp;';
let cFinish = '<img src="finish.png">&nbsp;';
let cSlewt = '<img src="blackflag.png">&nbsp;';
let cGround = '<img src="bus.png">&nbsp;';
let sortCol = 'TSK_AVG';
let jsonURL = getURL();

    function fetchData() {
		let rows = "";
        fetch(jsonURL)
            .then(response => response.json())
            .then(jsonData => {
                const items = jsonData.ITEMS;				
                
                // Clear existing table
                //document.getElementById("data").innerHTML = "";
                //console.log(jsonData);	
                // Append new rows to the table
											
				const table = document.getElementById('table');					
				const cells = table.rows[0].cells;
					
				sortItems(items);
					
                items.forEach(item => {
                   
				   let row = '<tr>';
					for (let i = 0; i < cells.length; i++) {						
						if (cells[i].style.display != 'none') {
							row += addCol(i, item);
						} 
					}					
					row += '</tr>';					
					rows += row;
                    
                });
				
				document.getElementById("data").innerHTML = rows;
                
            })
            .catch(error => console.error('Error fetching data:', error));
    }
	
	function getURL() {			
		const url = window.location.protocol + "//" + window.location.hostname + (window.location.port ? ':' + window.location.port : '') + "/json";
		return url;
	}

	function addCol(index, item){
		
		let col = '<td>';
		
		switch (index) {
			case 0: 
			    if (item.TSK_NEXT == 'Finished')  {  col += cFinish; } else if (item.AGL > 5) col += cAir; else col += cOnline;
				if (item.TSK_ONGROUND == 1) col += cGround;
				if (item.TSK_ENG == 1) col += cEngine;
				if (item.TSK_SLEWT == 1) col += cSlewt;
				col += item.ID;		
				break;
			case 1: 
				col = col + item.AC;		
				break;
			case 2: 
				col = col + item.TW + ' lbs';		
				break;
			case 3: 
				col = col + item.FLAPS ;		
				break;
			case 4: 
				col = col + item.IAS + ' kn';		
				break;
			case 5: 
				col = col + item.TAS + ' kn';		
				break;
			case 6: 
				col = col + item.GS + ' kn';		
				break;
			case 7: 
				col = col + item.TH;		
				break;
			case 8: 
				col = col + item.MSL + ' ft';		
				break;
			case 9: 
				col = col + item.AGL + ' ft';		
				break;
			case 10: 
				col = col + sToHms(item.TSK_TIME);		
				break;
			case 11: 
				col = col + item.TSK_AVG + ' kn';		
				break;
			case 12: 
				col = col + item.TSK_NEXT;		
				break;
			case 13: 
				col = col + item.TSK_DIS_WP + ' nm';		
				break;
			case 14: 
				col = col + item.TSK_DIS + ' nm';		
				break;
			case 15: 
				col = col + item.DIS + ' nm';		
				break;
			
		}
		
		col = col + '</td>';				
		return col;
	}
	
	function setSort (colName) {
		sortCol = colName;		
	}
	
	function sortItems(items) {
		items.sort((a, b) => b[sortCol] - a[sortCol]);
    }
	

    function changeFontSize(action) {
        const table = document.getElementById('table-container');
        let currentSize = window.getComputedStyle(table, null).getPropertyValue('font-size');
        currentSize = parseFloat(currentSize);
        if (action === 'increase') {
            table.style.fontSize = (currentSize + 1) + 'px';
        } else if (action === 'decrease') {
            table.style.fontSize = (currentSize - 1) + 'px';
        }
    }

    function toggleColumn(index) {
        const table = document.getElementById('table');
        const rows = table.rows;
        for (let i = 0; i < rows.length; i++) {
            const cells = rows[i].cells;
            if (cells[index].style.display === 'none') {
                cells[index].style.display = '';
            } else {
                cells[index].style.display = 'none';
            }
        }
    }

    function toggleFontColor() {
        const table = document.getElementById('table');
        const currentColor = window.getComputedStyle(table, null).getPropertyValue('color');
        if (currentColor === 'rgb(0, 0, 0)') { // Schwarz
            table.style.color = 'white';
        } else {
            table.style.color = 'black';
        }
    }
	
	function toggleSSCPanel() {
		var table = document.getElementById('table');
		var currentOpacity = window.getComputedStyle(table).backgroundColor;
        if (currentOpacity === 'rgba(255, 255, 255, 0.2)') {
			table.style.backgroundColor = 'rgba(255, 255, 255, 0.0)'; // 100% opacity
        } else {
			table.style.backgroundColor = 'rgba(255, 255, 255, 0.2)'; // 50% opacity
        }
	}
	
	
function sToHms(seconds) {
    const h = Math.floor(seconds / 3600);
    const m = Math.floor((seconds % 3600) / 60);
    const s = Math.floor(seconds % 60);

    const hh = h.toString().padStart(2, '0');
    const mm = m.toString().padStart(2, '0');
    const ss = s.toString().padStart(2, '0');

    return `${hh}:${mm}:${ss}`;
}
	
	
	
// function buildTable() {

	// let t = '<table id="table"><thead><tr id="toggle-header">'
				// <th>ID</th>
                // <th>AC</th>
                // <th style="display: none;">TW</th>              
                // <th>FLAPS</th>
                // <th style="display: none;">IAS</th>            
                // <th style="display: none;">TAS</th>            				
                // <th>GS</th>
				// <th style="display: none;">TH</th>
                // <th>MSL</th>            
				// <th style="display: none;">AGL</th>  
                // <th>TSK TIME</th>
				// <th>TSK AVG</th>
                // <th>NEXT WP</th>
				// <th>TO WP</th>
                // <th>TO FINISH</th>
                // <th>DISTANCE</th>
	// t += '</tr></thead><tbody id="data">';
	
	
    // t += '</tbody></table>';
// }	
	
	
    
	document.getElementById('table').addEventListener('click', function() {
        var colControls = document.getElementById('colcontrols');
        var buttons = document.getElementById('buttons');
        if (colControls.style.display === 'none' || colControls.style.display === '') {
            colControls.style.display = 'inline';          
        } else {
            colControls.style.display = 'none';            
        }
    });


	
    // Fetch data
    fetchData();
    
    // Schedule next fetch after 2 second
    setTimeout(() => {
        fetchData();
        
        // Repeat every second
        setInterval(fetchData, 1000);
    }, 2000);